default:
  image: "python:3.11"
  tags:
    - ci.inria.fr
    - small

variables:
  WORKON_HOME: .pipenv/venvs
  PIP_CACHE_DIR: .pipenv/pipcache

cache:
  key: pipenv
  paths:
    - .pipenv

before_script:
  - apt-get -qq update
  - apt-get install -qqy graphviz graphviz-dev
  - pip install --upgrade pipenv
  - pipenv sync --dev
  - source $(pipenv --venv)/bin/activate

stages:
  - Static Analysis
  - Test

mypy:
  stage: Static Analysis
  script:
    - python -m mypy --ignore-missing-imports --follow-imports=silent crdt/crdt.py
  allow_failure: true

black:
  stage: Static Analysis
  script:
    - black -t py310 -l 120 --check crdt/*.py
  allow_failure: true

unit testing:
  stage: Test
  script:
    - pytest --no-header -v -rs
